const Device = require("./Device");

module.exports = class IoTControler {
    static Parse(strCMD, Account, ControlerID, Client){
        var aCMD = strCMD.toString().split(" ");
        console.log("Parseing Command: '"+strCMD.toString()+"'");
        if (aCMD[0] == "sendto") IoTControler.SendTo(aCMD[1], Account, aCMD[2]);
        if (aCMD[0] == "addForwarder") IoTControler.addForwarder(Account, aCMD[1], ControlerID);
        if (aCMD[0] == "listDevices") IoTControler.listDevices(Account, Client);
    }


    static SendTo(DeviceID, Account, Value) {
        var IndexDevice = Account.getDeviceIndex(DeviceID);
        if (IndexDevice < 0 ) return;

        Account.Devices[IndexDevice].ClientConnection.write(Value);
    };


    static addForwarder(Account, DeviceID_ToForward, ForwardTo){
        //DeviceID_ToForward.trim();
        DeviceID_ToForward = DeviceID_ToForward.split("\n")[0];
        var DeviceIndex=Account.getDeviceIndex(DeviceID_ToForward);
        console.log("... DeviceIndex: "+DeviceIndex);
        if (DeviceIndex==-1) return;
        Account.Devices[DeviceIndex].addForwarder(ForwardTo);
        console.log("added forwarder to "+ForwardTo+ " for "+Account.Devices[DeviceIndex]);
    };


    static listDevices(Account, Client){
        var leng=Account.Devices.length;
        //console.log(Account.Devices);
        var dataOutput ="[";
        console.log("num Devices: "+leng);
        //Client.write(dataOutput);
        for (var n=0; n<leng; n++){
            console.log("["+n+",\""+Account.Devices[n].DeviceTyp+"\",\"" +Account.Devices[n].DeviceID+"\"]");
            dataOutput+="["+n+",\""+Account.Devices[n].DeviceTyp+"\",\"" +Account.Devices[n].DeviceID+"\"]";
            if (n<(leng-1)) dataOutput+=",\r\n";
            //Client.write(dataOutput);

        };// for
        dataOutput+="]\r\n";
        Client.write(dataOutput);
    };
}